#include <stdio.h>
#include <string.h>
#include <zlib.h>


char ct[16];
char ct2[16];

void generate_ct() {

    int i;

    ct[ 0x00 ] = 'e'; 
    ct[ 0x01 ] = 't';
    ct[ 0x02 ] = 'i';
    ct[ 0x03 ] = 'a';
    ct[ 0x04 ] = 'n';
    ct[ 0x05 ] = 'm';
    ct[ 0x06 ] = 's';
    ct[ 0x07 ] = 'u';
    ct[ 0x08 ] = 'r';
    ct[ 0x09 ] = 'w';
    ct[ 0x0a ] = 'd';
    ct[ 0x0b ] = 'o';
    ct[ 0x0c ] = 'g';
    ct[ 0x0d ] = 'h';
    ct2[ 0x00 ] = 'k';
    ct2[ 0x01 ] = '-';
    ct2[ 0x02 ] = 'v';
    ct2[ 0x03 ] = 'f';
    ct2[ 0x04 ] = 'l';
    ct2[ 0x05 ] = 'p';
    ct2[ 0x06 ] = 'j';
    ct2[ 0x07 ] = 'b';
    ct2[ 0x08 ] = 'x';
    ct2[ 0x09 ] = 'c';
    ct2[ 0x0a ] = 'z';
    ct2[ 0x0b ] = 'q';
    ct2[ 0x0c ] = 'y';

}

#define C(b) ct[ (b) ] 
#define C2(b) ct2[ (b) ] 



char* decompress_4bit_word( char* in ) {

    int part;
    unsigned char temp[100];
    unsigned char *i, *j;

    part = 0;
    i = in;
    j = temp;

    while( !  ( part == 0 & ( *i & 0xf0 ) == 0xf0 ) ||  ( part == 1 &&   ( *i & 0x0f ) == 0x0f ) )  {


        if( part == 0 && ( 0xf0 & *i ) != 0xe0 ) {

            *j++ = C( *i >> 4  );
            part = 1;

        }
        else if( part == 1 && ( 0x0f & *i ) != 0x0e ) {
            
            *j++ = C( *i & 0x0f );
            part = 0;
            i++;

        }
        else if( part == 0 && ( 0xf0 & *i ) == 0xe0 ) {

            *j++ = C2(*i & 0x0f);
            i++;
        
        }
        else if( part == 1 && ( 0x0f & *i ) == 0x0e ) {

            i++;
            *j++ = C2( *i >> 4  );
        
        }

    }
    *j = '\0';    

    //fprintf( stderr, "%s\n", temp );
    return strdup( temp );

}

char* file_read_4bit_decompressed(  FILE* file ) {

    unsigned char compressed[100];
    int in; 
    int i = 0;

    while( ( in = getc( file ) ) != EOF ) {

        compressed[i] = in;
        if( ( in & 0xf0 ) == 0xf0  || ( in & 0x0f ) == 0x0f ) {

            return decompress_4bit_word( compressed ) ;

        }
        i++;

    }

    return NULL;

}

char* file_read_4bit_decompressed_gzipped(  gzFile file ) {

    unsigned char compressed[100];
    int in; 
    int i = 0;

    while( ( in = gzgetc( file ) ) != EOF ) {

        compressed[i] = in;
        if( ( in & 0xf0 ) == 0xf0  || ( in & 0x0f ) == 0x0f ) {

            return decompress_4bit_word( compressed ) ;

        }
        i++;

    }

    return NULL;

}

void decompress_4bit( char* in_file, char* out_file ) {

    FILE* file; 
    FILE* out;
    int i; 
    char* word;
    unsigned char count;

    if( ( file = fopen( in_file, "rb" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n", in_file );
        exit(0);

    }

    if( ( out = fopen( out_file, "w" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n" );
        exit(0);

    }

    while( ( word = file_read_4bit_decompressed( file ) ) != NULL ) {

        fputs( word, out );
        fputc( '\n', out );

    }


    fclose( file );
    fclose( out );

}

void decompress_last_word( char* in_file, char* out_file ) {

    FILE* file; 
    FILE* out;
    int count;
    char buffer[100];
    char last_word[100];
    char* i;
    char* b;

    if( ( file = fopen( in_file, "r" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n", in_file );
        exit(0);

    }

    if( ( out = fopen( out_file, "w" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n" );
        exit(0);

    }

    fgets( last_word, 100, file );
    fputs( last_word, out );
    last_word[ strlen( last_word ) - 1 ] = '\0';
    while( ( count = fgetc( file ) ) != EOF ) {

        fgets( buffer, 100, file );

        i = &last_word[count];
        b = buffer;

        while( *b )
            *i++ = *b++;
        *i = '\0';
        
        fputs( last_word, out );


    }
    
    fclose( file );
    fclose( out );
}

void decompress_last_word_4bit( char* in_file, char* out_file ) {

    gzFile file; 
    FILE* out;
    int count;
    char buffer[100];
    char last_word[100];
    char* i;
    char* b;
    char* word;

    if( ( file = fopen( in_file, "rb" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n", in_file );
        exit(0);

    }

    if( ( out = fopen( out_file, "w" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n" );
        exit(0);

    }
    word = file_read_4bit_decompressed_gzipped( file ); 
    strcpy( last_word, word );
    fputs( word, out );
    fputc( '\n', out );
    free( word );
    while( ( count = getc( file ) ) != EOF ) {

        word = file_read_4bit_decompressed_gzipped( file ); 
        i = &last_word[count];
        b = word;

        while( *b )
            *i++ = *b++;
        *i = '\0';
        
        fputs( last_word, out );
        fputc( '\n', out );
        free( word );

    }
    
    fclose( file );
    fclose( out );


    
}

void decompress_last_word_4bit_gzipped( char* in_file, char* out_file ) {

    gzFile file; 
    FILE* out;
    int count;
    char buffer[100];
    char last_word[100];
    char* i;
    char* b;
    char* word;

    fprintf( stderr, "Decompressing 4bit compressed dictionary %s\n", in_file );

    if( ( file = gzopen( in_file, "rb" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n", in_file );
        exit(0);

    }

    if( ( out = fopen( out_file, "w" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n" );
        exit(0);

    }

    if( gzgets( file, buffer, 100 ) == NULL ) {

        fprintf( stderr, "Error reading from file %s\n", in_file );
        return;

    }

    if( strcmp( buffer, "DICTIONARY_COMPRESSED_4BIT\n" ) != 0 ) {

        fprintf( stderr, "Error! %s is not a 4bit compressed dictionary!\n", in_file );
        return;

    }

    word = file_read_4bit_decompressed_gzipped( file ); 
    strcpy( last_word, word );
    fputs( word, out );
    fputc( '\n', out );
    free( word );
    while( ( count = gzgetc( file ) ) != EOF ) {

        word = file_read_4bit_decompressed_gzipped( file ); 
        i = &last_word[count];
        b = word;

        while( *b )
            *i++ = *b++;
        *i = '\0';
        
        fputs( last_word, out );
        fputc( '\n', out );
        free( word );

    }
    
    gzclose( file );
    fclose( out );


    
}

void decompress_last_word_gzipped( char* in_file, char* out_file ) {

    gzFile* file; 
    FILE* out;
    int count;
    char buffer[100];
    char last_word[100];
    char* i;
    char* b;

    fprintf( stderr, "Decompressing compressed dictionary %s\n", in_file );
    
    if( ( file = gzopen( in_file, "rb" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n", in_file );
        exit(0);

    }

    if( ( out = fopen( out_file, "w" ) ) == NULL ) {

        fprintf( stderr, "Error opening file %s\n" );
        exit(0);

    }

    if( gzgets( file, buffer, 100 ) == NULL ) {

        fprintf( stderr, "Error reading from file %s\n", in_file );
        return;

    }


    
    if( strcmp( buffer, "DICTIONARY_COMPRESSED\n" ) != 0 ) {

        fprintf( stderr, "Error! %s is not a 4bit compressed dictionary!\n", in_file );
        return;

    }


    gzgets( file, last_word, 100 );
    fputs( last_word, out );
    last_word[ strlen( last_word ) - 1 ] = '\0';
    while( ( count = gzgetc( file ) ) != EOF ) {

        gzgets( file, buffer, 100 );

        i = &last_word[count];
        b = buffer;

        while( *b )
            *i++ = *b++;
        *i = '\0';
        
        fputs( last_word, out );


    }
    
    gzclose( file );
    fclose( out );
}

int main( int argc, char** argv ) {

    gzFile* file;
    char out_filename[100]; 
    char buffer[100];
    int i;
    
    if( argc == 2 ) {

        if( ( file = gzopen( argv[1], "r" ) ) == NULL ) {

            sprintf( buffer, "Error loading dictioary %s: ", argv[1] );
            perror( buffer );
            return;

        }

        if( gzgets( file, buffer, 100 ) == NULL ) {

            gzclose( file );
            return;

        }

    strcpy( out_filename, argv[1] );
    out_filename[ strlen( out_filename ) - 3 ] = '\0';

        if( strcmp( buffer, "DICTIONARY_COMPRESSED\n" ) == 0 )
            decompress_last_word_gzipped( argv[1], out_filename ); 
        else if( strcmp( buffer, "DICTIONARY_COMPRESSED_4BIT\n" ) == 0 ) {

           generate_ct();
//    decompress_4bit( argv[1], "decompressed_4bit" ); 


    decompress_last_word_4bit_gzipped( argv[1], out_filename ); 

        }
//    decompress_last_word( argv[2], "decompressed_last_word" ); 

    }
    else {

        fprintf( stderr, "Usage: %s <compressed dictionary>\n", argv[1] );

    }

}
