#ifndef __DICTIONARY_H__
#define __DICTIONARY_H__
#include "list.h" 

#define STATISTICAL_WORD_FREQUENCY_LIMIT 127

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif
typedef enum {

    DICTIONARY_NORMAL,
//    DICTIONARY_COMPRESSED, // runtime compression removed until the moon hits in to the sun
    DICTIONARY_STATISTICAL

} dictionary_type;

struct _dictionary {

    List* list;
    List *lookup_table[256];
//    GHashTable* decompress_hash;
    char* last_word;
    List* last_node;
    dictionary_type type;

};
typedef struct _dictionary Dictionary;

Dictionary* dictionary_new( dictionary_type dict_type ); 
Dictionary* dictionary_new_from_file( dictionary_type dict_type, char* filename ); 
//Dictionary* dictionary_new_from_list( dictionary_type dict_type, GList* list ); 
void dictionary_save( Dictionary* dict, char* filename ); 
void dictionary_destroy( Dictionary* dict ); 
void dictionary_add_word( Dictionary* dict, const char* word, int rehash ); 
void dictionary_remove_word( Dictionary* dict, const char* word, int rehash ); 
//void dictionary_add_word_list( Dictionary* dictionary, GList* list ); 
//void dictionary_remove_word_list( Dictionary* dictionary, GList* list ); 
void dictionary_load( Dictionary* dict, char* filename ); 
char* dictionary_predict_word( Dictionary* dict, char* word, int cycle_words ); 
void dictionary_predict_reset( Dictionary* dict ); 
void dictionary_print( Dictionary* dict );
int dictionary_has_word( Dictionary* dict, char* word ); 

#endif
