
#include "dictionary.h"

struct _predictive_dictionary {

    Dictionary* common_dictionary; // the dictionary of the most frequent used word, of type DICTIONARY_STATISTICAL
    Dictionary* word_dictionary; // the dictionary that holds a static dictionary, of type DICTIONARY_NORMAL
    Dictionary* cycle_dictionary; // a pointer do keep track of things when cycling through the dictionaries
    char* common_dictionary_filename; // path to the common dictioanry. Stats are saved when calling destroy()
    char* last_predicted_word;
    int learning;
    
};
typedef struct _predictive_dictionary PredictiveDictionary;


PredictiveDictionary* predictive_dictionary_new( char* common_dict_filename, char* word_dict_filename ); 
void predictive_dictionary_destroy( PredictiveDictionary* dict ); 
void predictive_dictionary_update_with_word( PredictiveDictionary* dict, char* word );
char* predictive_dictionary_predict( PredictiveDictionary* dict, char* word ); 
char* predictive_dictionary_cycle( PredictiveDictionary* dict, char* word ); 
void predictive_dictionary_set_learning( PredictiveDictionary* dict, int learn );


